#include "MainWindow.h"
#include <QtCore>
#include <iostream>

using namespace std;

MainWindow::MainWindow(QWidget *parent) :
QMainWindow(parent),
txtPath (NULL),
btnPath (NULL),
txtLogs (NULL),
btnDoIt (NULL),
grid (NULL),
player (NULL),
fdlg (this)
{
    QWidget *central = new QWidget (this);
    txtPath = new QLineEdit (central);
    btnPath = new QPushButton ("Select...", central);
    txtLogs = new QPlainTextEdit (central);
    btnDoIt = new QPushButton ("Push me", central);
    grid = new QGridLayout (central);

    grid->addWidget(txtPath, 0,0, 1,3);
    grid->addWidget(btnPath, 0,3);
    grid->addWidget(txtLogs, 1,0, 1,4);
    grid->addWidget(btnDoIt, 2,0, 1,4);
    central->setLayout (grid);
    this->setCentralWidget (central);

    log ("Before creating objects");
    playlist = new QMediaPlaylist;
    log ("Created QMediaPlaylist");
    player = new QMediaPlayer (this);
    log ("Created QMediaPlayer");
    playlist->setMediaObject (player);
    log ("setMediaObject");
    player->setVolume (50);
    log ("setVolume");

    QObject::connect (btnDoIt, SIGNAL (clicked ()),
                      this   , SLOT   (btnClicked ()));

    QObject::connect (btnPath, SIGNAL (clicked ()),
                      &fdlg  , SLOT   (show ()));
    QObject::connect (&fdlg  , SIGNAL (fileSelected (const QString &)),
                      txtPath, SLOT   (setText (const QString &)));
}//MainWindow::MainWindow

MainWindow::~MainWindow()
{
    playlist->clear ();
    delete playlist;
    playlist = NULL;
    delete player;
    player = NULL;
}//MainWindow::~MainWindow

void
MainWindow::log (const QString &strText, int level/* = 10*/)
{
    QDateTime dt = QDateTime::currentDateTime ();
    QString strLog = QString("%1 : %2 : %3")
                     .arg(dt.toString ("yyyy-MM-dd hh:mm:ss.zzz"))
                     .arg(level)
                     .arg(strText);
    txtLogs->appendPlainText (strText);
    cout << strText.toStdString () << endl;
}//MainWindow::log

void
MainWindow::btnClicked ()
{
    QString strPath = txtPath->text ();
    if ((0 == strPath.size ()) || (!QFileInfo(strPath).exists ()))
    {
        emit log ("File does not exist");
        return;
    }

    playlist->clear ();
    playlist->addMedia (QUrl::fromLocalFile (strPath));
    playlist->setCurrentIndex (1);
    player->play ();

    log (QString("Tried playing %1").arg (strPath));
}//MainWindow::btnClicked
